from datetime import date

from pydantic import BaseModel


class DirectorBaseSchema(BaseModel):
    first_name: str | None = None
    last_name: str | None = None


class DirectorIdSchema(BaseModel):
    id: int

    class Config:
        from_attributes = True


class DirectorListSchema(DirectorBaseSchema, DirectorIdSchema):
    pass


class DirectorGetSchema(DirectorBaseSchema, DirectorIdSchema):
    born: date
    description: str | None


class DirectorPostSchema(DirectorBaseSchema):
    born: date
    description: str | None = None


class DirectorPatchSchema(DirectorBaseSchema):
    born: date | None = None
    description: str | None = None
