from db.repositories.movie import MovieRepository, DirectorRepository, GenreRepository


class MovieService:
    movie_repository = MovieRepository()
    director_repository = DirectorRepository()
    genre_repository = GenreRepository()

    async def get_list_movie(self, **kwargs):
        return await self.movie_repository.get_list(**kwargs)

    async def get_movie(self, id: int):
        return await self.movie_repository.get(id)

    async def create_movie(self, **kwargs):
        director_id = kwargs.get('director')
        genre_id = kwargs.get('genre')

        director = await self.director_repository.get(director_id)
        genre = await self.genre_repository.get(genre_id)

        kwargs['director'] = director
        kwargs['genre'] = genre

        return await self.movie_repository.create(**kwargs)

    async def update_movie(self, id: int, **kwargs):
        director_id = kwargs.get('director')
        genre_id = kwargs.get('genre')

        if director_id is not None:
            director = await self.director_repository.get(director_id)
            kwargs['director'] = director

        if genre_id is not None:
            genre = await self.genre_repository.get(genre_id)
            kwargs['genre'] = genre

        return await self.movie_repository.update(id, **kwargs)

    async def delete_movie(self, id: int):
        return await self.movie_repository.delete(id)
